#   -*- coding: utf-8 -*-
#
#   Copyright (C) 2009 Petri Damstén <damu@iki.fi>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU Library General Public License as
#   published by the Free Software Foundation; either version 2, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details
#
#   You should have received a copy of the GNU Library General Public
#   License along with this program; if not, write to the
#   Free Software Foundation, Inc.,
#   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#

import os, sys
from PyQt4.QtCore import *
from PyQt4.QtGui  import *
from PyQt4 import uic
from PyKDE4.plasma import Plasma
from PyKDE4.plasmascript import Applet
from PyKDE4.kdecore import *
from PyKDE4.kdeui import *

class Hello(Applet):
    def __init__(self, parent, args = None):
        Applet.__init__(self, parent)

    def init(self):
        print '~~~ init'
        self.setAspectRatioMode (Plasma.IgnoreAspectRatio)
        self.setHasConfigurationInterface (False)

        # Init configuration
        self.conf=self.config('pyhello')

        self.setPopupIcon('media-optical-audio')
        if not self.extender().hasItem('pyhello'):
            self.extenderItem = Plasma.ExtenderItem(self.extender())
            self.initExtenderItem(self.extenderItem)


    def initExtenderItem(self, item):
        self.layout = QGraphicsLinearLayout(Qt.Vertical)
        self.scroll = Plasma.ScrollWidget (item)
        self.gridwidget = QGraphicsWidget (self.scroll)
        self.gridlayout = QGraphicsGridLayout (self.gridwidget)
        self.gridwidget.setLayout (self.gridlayout)
        self.scroll.setWidget (self.gridwidget)
        self.button = Plasma.PushButton(item)
        self.button.setText('Change')
        
        self.item1 = Plasma.IconWidget ("kde", self.gridwidget)
        self.item2 = Plasma.IconWidget ("kde", self.gridwidget)
        self.item3 = Plasma.IconWidget ("kde", self.gridwidget)
        self.item4 = Plasma.IconWidget ("kde", self.gridwidget)
        self.item5 = Plasma.IconWidget ("kde", self.gridwidget)
        self.item6 = Plasma.IconWidget ("kde", self.gridwidget)
        self.item7 = Plasma.IconWidget ( "kde", self.gridwidget)
        self.gridlayout.addItem(self.item1, 0, 0)
        self.gridlayout.addItem(self.item2, 0, 1)
        self.gridlayout.addItem(self.item3, 1, 0)
        self.gridlayout.addItem(self.item4, 1, 1)
        self.gridlayout.addItem(self.item5, 2, 0)
        self.gridlayout.addItem(self.item6, 2, 1)
        self.gridlayout.addItem(self.item7, 3, 0)
        self.layout.addItem(self.scroll)
        self.layout.addItem(self.button)

        self.widget = QGraphicsWidget(item)
        self.widget.setLayout(self.layout)

        item.setWidget(self.widget)
        item.setName('pyhello')
        item.setTitle(i18n('Python Hello'))
        item.showCloseButton()


def CreateApplet(parent):
    return Hello(parent)

